/**********************************************************************
 *
 *    ***  HAPPy Pascal Compiler ***
 *
 *             錾̃RpC
 *
 *    x錾        void labeldecl(Set fsys)
 *    萔`          void constdecl(Set fsys)
 *    ^`            void typedecl(Set fsys)
 *    ϐ錾          void vardecl(Set fsys,ctp *fprocp)
 *    葱/֐錾   void procfuncdecl
 *                            (Set fsys,enum symbol fsy,ctp **pffwdptr)
 *
 *           Copyrignt (c) H.Asano 1992
 *
 **********************************************************************/

#define EXTERN extern

#include <string.h>
#include "pascomp.h"

extern void block(Set,enum symbol,ctp*);
extern int crelabel(void) ;
extern void pcerr(int,char*) ;
extern char *inttoch(long)   ;
extern char *inttoch(long)   ;
extern Set  *mkset(Set*,int,...) ;
extern Set  *orset(Set*,Set*) ;
extern void insymbol(void) ;
extern void skip(Set) ;
extern void updatelc(int) ;
extern ctp  *mkctp(char*,enum idclass,stp*,ctp*) ;
extern void enterid(ctp*) ;
extern ctp *searchid(Set) ;
extern ctp *searchsection(ctp*)  ;
extern boolean typ(Set, stp**,int*) ;
extern void constant(Set,stp**,union valu*)  ;
extern int  align(stp*,int) ;
extern void applied(ctp*,int)   ;
extern ctp  *mkctp(char*,enum idclass,stp*,ctp*) ;
extern void *Malloc(int) ;
extern void *mark(void)  ;
extern void release(void*) ;
extern void putfilename(char*,int,int);

/*********************************************/
/*     labeldecl() : label錾RpC   */
/*********************************************/
void labeldecl(Set fsys)
{
  lbp     *llp  ;
  boolean redef ;                       /* redefine flag              */
  boolean test  ;                       /* JԂ̂߂Ɏg       */
  Set     ws    ;                       /* ƗpW                 */

     do {
      if(sy == intconst) {              /* ̎                   */ 
       redef = false ; 
       llp = display[top].flabel ;
       while(llp) {                     /* label e[u T[`      */
        if(llp->labval != (int)val.ival) llp = llp->nextlab ;
        else {                          /*  l            */
         redef = true ;
         pcerr(166,inttoch(val.ival)) ; /*  xēx錾ꂽ    */
         break ;
        }
       }
       if(! redef) {                       /* Đ錾łȂƂ (OK̎)*/
        llp = (lbp*)Malloc(sizeof(lbp)) ;  /* label e[u m     */
        llp->labval  = (int)val.ival ;     /* xl                */
        llp->labname = crelabel() ;        /* P-codẽx    */
        llp->defined = false    ;          /* `Ƃ            */
        llp->nextlab = display[top].flabel ;
        display[top].flabel = llp ;        /* ߲̂Ȃ       */

        if((val.ival < 0) || (val.ival > 9999)) /* 0`9999̊ԂłȂ*/
         pcerr(164,"") ;                   /* xĂ      */
       }
       insymbol() ;
      }
      else pcerr(164,"") ;              /* łȂ x    */

      mkset(&ws, comma,semicolon, -1) ;
      orset(&ws, &fsys) ;
      if( ! inset(ws,sy)) {      /* symbol̐`FbN       */
       pcerr(6,"")      ;        /*   sȋLꂽ             */
       skip(ws)         ;        /*   Ƃ܂œǂݔ΂     */
      }

      test = (sy == comma) ;
      if(test) insymbol()  ;     /*  , ȂΎsymbolǂ        */
     } while(test)         ;     /*  , łΌJԂ              */

     if(sy == semicolon) insymbol() ;    /* ; 玟symbol     */
     else                pcerr(14,"");   /* ; Ȃ@               */
}

/*********************************************/
/*     constdecl() : 萔`̃RpC  */
/*********************************************/
void constdecl(Set fsys)
{
  ctp   *lcp ;
  stp   *lsp ;
  union valu  lvalu ;
  Set   ws1   ;
  Set   ws2   ;

     ws1 = fsys             ;
     addset(ws1, ident)     ;           /* ws1 = fsys + [ident]       */
     ws2 = fsys             ;
     addset(ws2, semicolon) ;           /* ws2 = fsys + [semicolon]   */

     if(sy != ident) {
      pcerr(2,id)    ;                  /* OȂ                 */
      skip(ws1)            ;            /* fsys+[ident]܂œǂݔ΂ */
     }

     while(sy == ident) {
      lcp = mkctp(id,konst,nil,nil) ; 
      insymbol() ;
      if(op == eqop) insymbol() ;       /* = Ȃ symbolǂ    */
      else           pcerr(16,"") ;     /* = Ȃ                   */
      constant(ws2, &lsp, &lvalu) ;     /* Eӂ̏                 */
      lcp->idtype = lsp           ;     /* Eӂ̌^ (lsp)             */
      lcp->n.values = lvalu       ;     /* Eӂ̒l (lavlu)           */
      enterid(lcp)                ;     /* ӂ̖Oo^           */

      if(sy == semicolon) {             /* ; Ȃ                   */ 
       insymbol()  ;                    /*  symbolǂ          */
       if( ! inset(ws1,sy)) {           /*    fsys܂͖OłȂ@  */
        pcerr(6,"")   ;                 /*    sȋLꂽ      */
        skip(ws1)  ;                    /* fsys+identsymbol܂skip */
       }
      } else pcerr(14,"")  ;            /* ; Ȃ@                 */
     }
}

/*********************************************/
/*      typedecl() : ^`̃RpC    */
/*********************************************/
void typedecl(Set fsys)
{
  ctp *lcp ;
  ctp *lcp1 ;                           /* OQƉp             */
  ctp *lcp2 ;                           /* lcp11O̒l            */
  stp *lsp ;
  int lsize ;
  Set ws ;

     typevar = true ;                   /* ^`ł̌^̏       */
     
     if(sy != ident) {                  /* OłȂ                 */
      pcerr(2,"") ;                     /*  OȂ                */
      mkset(&ws, ident, -1) ;
      orset(&ws, &fsys)     ;
      skip(ws)              ;           /* fsys+[ident] ܂œǂݔ΂*/
     }

     while(sy == ident) {               /*                            */
      lcp = mkctp(id,types,nil,nil) ;   /*  ÕGAm        */
      insymbol()            ;
      if(op == eqop) insymbol() ;       /* = ȂΎsymbol         */
      else pcerr(16,"")     ;           /*  =Ȃ                   */

      mkset(&ws, semicolon,-1) ;
      orset(&ws,&fsys) ;
      typ(ws, &lsp, &lsize) ;
      if(lsp && !lsp->assignflag && lsp->form != files) 
                                        /* t@C^܂ތ^̎     */
       pcerr(608,"") ;                  /* Ǐt@C͑ʖ         */
      lcp->idtype = lsp     ;
      enterid(lcp)          ;

   /*** OQƃXĝ`ꂽ^QƂĂ̂ ***/
      lcp1 = fwptr ;
      while(lcp1) {
       if(strcmp(lcp1->name, lcp->name) == 0) {     /* ^     */
        lcp1->idtype->sf.pt.eltype = lcp->idtype ;  /* ^       */
        if(lcp1 != fwptr) lcp2->next = lcp1->next ; /*  `F[O*/
        else fwptr = lcp1->next ;       /* fwptr擪͎̎Vfwptr */
       }
       else lcp2 = lcp1 ;               /* ̃[v̂߂ɑޔ     */
       lcp1 = lcp1->next ;
      }

      if(sy == semicolon) {
       insymbol() ;
       mkset(&ws,ident,-1) ;
       orset(&ws,&fsys) ;
       if(! inset(ws,sy)) {
        pcerr(6,"") ;                   /* sȋLꂽ         */
        skip(ws)    ;                   /* fsys+[ident]܂œǂݔ΂ */
       }
      } else pcerr(14,"") ;             /* ; Ȃ                   */
     }

     while(fwptr) {                     /* OQƂ̎       */
      pcerr(117,fwptr->name) ;          /*   OQƖ           */
       fwptr = fwptr->next   ;
     } ;
}

/*********************************************/
/*      vardecl() : var߂̃RpC        */
/*********************************************/
void vardecl(Set fsys,ctp *fprocp)
{
  static fileno = 0 ;
  ctp *lcp ;
  ctp *nxt ;
  stp *lsp ;
  extfilep *extp ;
  int lsize ;
  boolean test;
  boolean notfound ;
  Set  ws ;

     nxt = nil ;
     typevar = false ;                  /* ϐ`ł̌^̏     */

     do {
      do {
       if(sy == ident) {
        lcp = mkctp(id,vars,nil,nxt) ;  /* OϐƂēo^       */
        lcp->n.v.vkind = actual ;
        lcp->n.v.vlev  = level  ;
        enterid(lcp) ;
        nxt = lcp ;

        insymbol() ;
       }
       else pcerr(2,id) ;               /* OȂ                 */

       mkset(&ws, comma, colon, -1) ;   /* ws = [comma,colon]         */
       orset(&ws, &fsys)            ;   /*     + fsys                 */
       orset(&ws, &typedels)        ;   /*     + typedels             */
       if(! inset(ws,sy)) {
        pcerr(6,"")             ;       /*  sȋLꂽ        */
        addset(ws,semicolon)    ;
        skip(ws)                ;       /*  񕜂̂ߓǂݔ΂  */
       }

       if(test = (sy == comma)) insymbol() ;  /* , Ȃ玟symbol     */
      } while(test) ;                   /*       , ȂJԂ       */

      if(sy == colon) insymbol() ;      /* : Ȃ玟symbol           */
      else pcerr(5,"")           ;      /* : Ȃ                   */

      ws = fsys ;
      orset(&ws,&typedels) ;
      addset(ws,semicolon) ;
      typ(ws, &lsp, &lsize)   ;
      if(lsp && !lsp->assignflag && lsp->form != files) 
                                        /* t@C^܂ތ^̎     */
       pcerr(608,"") ;                  /* Ǐt@C͑ʖ         */

      while(nxt) {
       updatelc(align(lsp,lc) - lc);    /* ϐ̊JnԒn     */
       nxt->idtype = lsp      ;         /* ϐ̌^                   */
       nxt->n.v.vaddr = lc    ;         /* ϐ̊Ԓn         */
       if(lsp && lsp->form == files)    /*  t@Cϐ̎          */
        if(!fprocp && fextfilep) {      /*    CubN
                                            vO鎞    */
         extp = fextfilep ;
         notfound = true  ;
         while(extp && notfound) {      /* vOƏƍ       */
          if(!strcmp(extp->filename,nxt->name)) { /* ɏO */
           if(++fileno > Maxfileno)     /* őt@CzĂ */
            pcerr(600,inttoch((long)Maxfileno)) ;
           putfilename(nxt->name,lc,nxt->idtype->size) ;
                                        /*  t@Co͂    */
           notfound = false ;
          }
          extp = extp->nextfile  ;
         }
         if(notfound) pcerr(608,"") ;   /* Ǐt@C͑ʖ         */
        }
        else pcerr(608,"") ;            /* CubNȊO܂
                                           vOȂ     */ 
       updatelc(lsize)  ;               /* lc XV                    */
       nxt = nxt->next  ;
      }

      if(sy == semicolon) {
       insymbol() ;
       ws = fsys  ;
       addset(ws,ident) ;
       if(! inset(ws,sy)) {
        pcerr(6,"") ;                   /* sȋLꂽ         */
        skip(ws)    ;                   /* fsys+[ident]܂œǂݔ΂ */
       }
      }
      else pcerr(14,"") ;               /* ; Ȃ                   */
     
     } while((sy == ident) || (inset(typedels,sy))) ;
}

/*************************************************/
/*  procfuncdecl() : procedure/function錾  */
/*                             RpC        */
/*************************************************/

typedef enum prmkind { normal,          /* ubNƌꂽ   */
                       procfunc }       /* ֐葱̈      */
             prmkind ;
             
static void pfparmlist(ctp**,Set,Set,boolean,prmkind) ;
static void functype(Set,ctp*,boolean) ;
static ctp  *pfident(Set,enum symbol,boolean*,boolean*)   ;
static void prmpflist(Set,ctp**,prmkind) ;
static void prmvarlist(Set,Set,ctp**,prmkind)  ;
                       
void procfuncdecl(Set fsys,enum symbol fsy,ctp **pffwdptr)
{

  int oldlc ;                           /* location counter ޔ    */
  int oldlevel ;                        /* levelޔ                */
  int oldtop   ;                        /* topޔ                  */
  ctp *lcp     ;                        /* proc/func̖O|C^    */
  ctp *lcp1,*lcp2  ;                    /* O錾p̃|C^   */
  void *markadr ;                       /* ꊇAhX           */
  boolean forw ;                        /* łɐ錾Ă鎞true */
  boolean err160 ;
  Set ws       ;

     oldlc = lc   ;                     /* location counterޔ */
     lc  = lcaftermarkstack ;           /* Vlcݒ         */
     
     lcp = pfident(fsys,fsy,&forw,&err160) ; /* Ȍ            */
     
     oldlevel = level ;                 /* ̐ޔ             */
     oldtop   = top   ;                 /* display擪ʒuޔ  */

     if(level < Maxlevel) level++ ;     /* I[ołȂΐ𑝂₷*/
     else pcerr(604,inttoch((long)Maxlevel)) ;
                                        /* 葱֐̓q[*/
     if(top   < Displimit) {            /* display܂鎞        */
      top++ ;                           /* Vdisplayݒ*/
      display[top].fname  = (forw) ? lcp->next : nil ;
      display[top].flabel = nil  ;
      display[top].aname  = nil  ;
      display[top].occur  = blck ;
      display[top].funcname = (fsy==funcsy) ? lcp : nil ; /* ֐   */
      display[top].funcassign = false ; /* ֐ւ̑(葱) */
     }
     else pcerr(603,inttoch((long)Displimit)) ;
                                        /* O̓q[     */

     if(fsy == procsy) {                /* 葱̎                 */
      mkset(&ws,semicolon,-1) ;
      pfparmlist(&(lcp->next),ws,fsys,forw,normal) ;
     }
     else {
      mkset(&ws,semicolon,colon,-1);
      pfparmlist(&(lcp->next),ws,fsys,forw,normal) ;
      functype(fsys,lcp,forw);          /* ֐̌^̏             */
     }

     if(sy == semicolon) insymbol() ;
     else pcerr(14,"") ;                /* ; Ȃ                   */

     if((sy==ident) && (strcmp(id,"forward")==0)) {
                                        /* forwardw߂      */
      if(forw)
       pcerr(161,lcp->name) ;           /* ĂёO錾ꂽ         */
      else if(!err160 && ((lcp->klass==proc) || (lcp->klass==func))) {
       lcp->n.pf.sd.d.af.a.fwdptr=*pffwdptr; /* O錾Ȃ    */
       *pffwdptr = lcp ;
       lcp->n.pf.sd.d.af.a.forwdecl = true ;
      } 
      insymbol() ;
      if(sy == semicolon) insymbol() ;
      else pcerr(14,"") ;               /* ; Ȃ                   */
      if(! inset(fsys,sy)) {            /* I[LɂȂ           */
       pcerr(6,"") ;                    /*   sȋLꂽ       */
       skip(fsys)  ;                    /*   ǂݔ΂               */
      }
     }
     else {                             /* forwardw߂Ȃ        */
      lcp->n.pf.sd.d.af.a.forwdecl = false ;
      lcp1 = *pffwdptr ;                /* O錾XgO     */
      while(lcp1) {
       if(strcmp(lcp1->name,lcp->name) == 0) {
        if(lcp1 != *pffwdptr)
         lcp2->n.pf.sd.d.af.a.fwdptr = lcp1->n.pf.sd.d.af.a.fwdptr ;
        else *pffwdptr = lcp1->n.pf.sd.d.af.a.fwdptr ;
       }
       else lcp2 = lcp1 ;
       lcp1 = lcp1->n.pf.sd.d.af.a.fwdptr ;
      }
      markadr = mark() ;                /* ꊇAhX}[N   */
      do {
       block(fsys,semicolon,lcp) ;      /* ubN               */
       if(sy == semicolon) {
        insymbol() ;
        mkset(&ws,beginsy,procsy,funcsy,-1);
        if(! inset(ws,sy)) {
         pcerr(6,"") ;                  /* sȋLꂽ         */
         skip(ws)    ;                  /* ǂݔ΂                 */
        }
       }
       else pcerr(14,"") ;              /* ; Ȃ                   */
      } while(! inset(ws,sy)) ;         /* begin,procedure,functionȂ甲*/
      release(markadr) ;                /* heapꊇ       */
     }

     level = oldlevel ;                 /* O̐ɕA             */
     top   = oldtop   ;                 /* Odisplay擪ɕA      */
     lc    = oldlc    ;                 /* Olocation counterɕA */
}

/***************************************/
/* pfident() : proc/func̖Ȍ   */
/***************************************/
static ctp *pfident(Set fsys,enum symbol fsy,boolean *ffwd,boolean *err160)
{
  ctp *lcp,*lcp1 ;
  boolean forw = false ;                /* OQƐ錾tO         */

     *err160 = false ;
     
     if(sy != ident) {                  /* OłȂ                 */
      pcerr(2,"") ;                     /*   OȂ               */
      insymbol()  ;
      return(ufctptr) ;                 /*  `p̖OGAԋp*/
     }

     lcp = searchsection(display[top].fname) ; /* 疼OT*/
     if(lcp)                            /* O           */
      if((lcp->klass == proc) || (lcp->klass == func)) { /*forward錾*/
       forw = (((lcp->klass==proc) && (fsy==procsy)) ||  /*Ă */
               ((lcp->klass==func) && (fsy==funcsy)))    /*`FbN */
           && (lcp->n.pf.sd.d.pfkind==actual)
           && (lcp->n.pf.sd.d.af.a.forwdecl)  ;
       if(! forw) {
        pcerr(160,id) ;                 /* ɐȐ錾sĂ*/
        *err160 = true ;                /* Ȃ胄NUȂł    */
        forw    = true ;
       }
      }
      else pcerr(101,lcp->name);        /* O̓d`G[       */
     else {                             /* OȂ     */
      lcp = (fsy == procsy) ? mkctp(id,proc,nil,nil)  /* OGAm*/
                            : mkctp(id,func,nil,nil) ;
      lcp->n.pf.pfdeckind     = declared  ;
      lcp->n.pf.sd.d.pfkind   = actual    ;
      lcp->n.pf.sd.d.pflev    = level     ;
      lcp->n.pf.sd.d.af.a.pfname   = crelabel();
      enterid(lcp) ;                    /* O̓o^                 */
     }
     if(forw) {                         /* O錾ꂽO̎     */
      lcp1 = lcp->next ;                /*    ϐ̊        */
      while(lcp1 && lcp1->next)         /* Ō̈𓾂           */
       lcp1 = lcp1->next ;
      switch(lcp1->klass) {
       case vars :                     /* ϐ                        */
              updatelc(lcp1->n.v.vaddr - lc) ;
              if(lcp1->n.v.vkind==actual){ /* l                  */
               if(lcp1->idtype)        /*   ^G[łȂ        */
                updatelc(lcp1->idtype->size); /* TCYi߂       */
              }
              else                     /*   ϐ                  */
               updatelc(ptrsize);      /*     |C^TCYi߂*/
             break ;
       case proc :
       case func :                      /* 葱 ֐                */
             updatelc((lcp1->n.pf.sd.d.af.f.adradr + ptrsize) - lc) ;
             break ;
      }
     }

     insymbol()   ;
     *ffwd = forw ;
     return(lcp)  ;
}

/****************************************/
/*  functype() : ֐̌^           */
/****************************************/
static void functype(Set fsys,ctp *fcp,boolean forw)
{
  ctp *lcp1;
  stp *lsp ;
  Set ws ;

     if(sy == colon) {                  /* :                      */
      insymbol() ;                      /*  ^ǂ                  */
      if(sy == ident) {
       if(forw) pcerr(122,fcp->name) ;  /* Ăь^Ă͂Ȃ   */
       mkset(&ws,types,-1) ;
       lcp1 = searchid(ws) ;            /* ^T               */
       fcp->idtype = lsp = lcp1->idtype  ;
       if(lsp) {
        mkset(&ws,scalar,subrange,pointer,-1);
        if(! inset(ws,lsp->form)) {     /* ^XJ͈͌^|C^łȂ*/
         pcerr(120,fcp->name) ;         /* ֐̌^̌             */
         fcp->idtype = nil ;
        }
       } 
       insymbol() ;
      }
      else {
       pcerr(2,"") ;                    /* OȂ                 */
       ws = fsys ;
       addset(ws,semicolon) ;
       skip(ws)  ;                      /* ǂݔ΂                 */
      }
     }
     else                               /* : Ȃ                  */
      if(! forw) pcerr(123,fcp->name);  /* ֐̐錾Ɍ^Ȃ        */
}

/*****************************************/
/* pfparamlist() : p[^Xg  */
/*****************************************/
static void pfparmlist(ctp **fcp,Set fsys,Set fpfsys,boolean forw,prmkind kind)
{
  ctp *lcp1,*lcp2,*lcp3 ;
  Set ws,ws1     ;
  Set prmbegsys  ;                      /* ̍ŏsymbolƂOK̂*/

     mkset(&prmbegsys, ident,varsy,procsy,funcsy, -1);
     lcp1 = nil ;

     ws = fsys ;
     addset(ws,lparent) ;
     if(! inset(ws,sy)) { 
      pcerr(7,"") ;                     /* ̕тɌ肪     */
      orset(&ws,&fpfsys) ;
      skip(ws)    ;                     /* ǂݔ΂                 */
     }

     if(sy == lparent) {
      if(forw) pcerr(119,"") ;          /* O錾Ă̂ň͑ʖ*/
      insymbol() ;
      if(! inset(prmbegsys,sy)) {
       pcerr(7,"") ;                    /* ̕тɌ肪     */
       mkset(&ws,ident,rparent,-1) ;
       orset(&ws,&fpfsys) ;
       skip(ws)    ;                    /* ǂݔ΂                 */
      }

      ws = prmbegsys ;
      orset(&ws,&fpfsys) ;
      while(inset(prmbegsys,sy)) {      /* ̊JnsymbolƂok̊*/
       switch(sy) {
        case procsy :
        case funcsy : prmpflist(fpfsys,&lcp1,kind) ;   /* 葱֐*/
                      break ;      
        default     : prmvarlist(fsys,fpfsys,&lcp1,kind) ; /* ϐ,l*/
       }
       if(sy == semicolon) {
        insymbol() ;
        if(! inset(ws,sy)) {
         pcerr(7,"") ;                  /* ̕тɌ肪     */
         mkset(&ws1,ident,rparent,-1);
         skip(ws1) ;                    /* ǂݔ΂                 */
        } 
       }
      }

      if(sy == rparent) insymbol() ;
      else              pcerr(4,"") ;   /* ) Ȃ                   */
     }

     /* reverse pointers and reserve local cells for copies of
        multiple values  */

     lcp3 = nil ;
     while(lcp1) {                      /* ŏlcp1͍ŌҰw*/
      lcp2 = lcp1->next ;
      lcp1->next = lcp3 ;
      if(kind == normal)                /* ubNƌ   */ 
       if(lcp1->klass == vars)          /*  ϐ̎                  */
        if(lcp1->idtype)
         if((lcp1->n.v.vkind==actual) &&     /* Ǐϐ(ln)    */
            (lcp1->idtype->form > power)) {  /* z񥃌R[h̎     */
          updatelc(align(lcp1->idtype,lc) - lc) ;
          lcp1->n.v.vaddr = lc ;        /* ϐAhX       */  
          updatelc(lcp1->idtype->size);
         }
      lcp3 = lcp1 ;
      lcp1 = lcp2 ;
     }

     if(((kind==normal) && (!forw)) || (kind==procfunc) )
      *fcp = lcp3 ;                     /* ̕тݒ           */
}

/*******************************************/
/* prmpflist() : 葱֐p[^ */
/*******************************************/
static void prmpflist(Set fsys,ctp **fcp1,prmkind kind)
{
  ctp *lcp;
  enum symbol lsy ;
  int oldtop ;
  Set ws  ;
  
  /****** 葱֐̏ *****/
   
     lsy = sy   ;
     insymbol() ;
     if(sy != ident) {                  /* OłȂ                 */
      pcerr(2,"") ;                     /*   OȂ               */
      insymbol()  ;
      lcp = ufctptr ;                   /* OȂ̉̃GA   */
     }
     else {
      lcp = (lsy == procsy) ? mkctp(id,proc,nil,*fcp1)/* OGAm*/
                            : mkctp(id,func,nil,*fcp1) ;
      lcp->n.pf.pfdeckind     = declared  ;
      lcp->n.pf.sd.d.pfkind   = formal    ;       /* 葱֐  */
      lcp->n.pf.sd.d.pflev    = level     ;       /* `         */
      enterid(lcp) ;                    /* O̓o^                 */
     }
     *fcp1 = lcp ;
     
  /***** p[^т̏ *****/
  
     oldtop = top ;
     if(top   < Displimit) {            /* display܂鎞        */
      top++ ;                           /* Vdisplayݒ*/
      display[top].fname  = nil  ;
      display[top].aname  = nil  ;
      display[top].flabel = nil  ;      /* ӖȂ                   */
      display[top].occur  = blck ;      /* ӖȂ                   */ 
     }
     else pcerr(603,inttoch((long)Displimit)) ;
                                        /* O̓q[     */

     insymbol() ;  
     if(lsy == procsy) {                /* 葱̎                 */
      mkset(&ws,rparent,semicolon,-1) ;
      pfparmlist(&(lcp->n.pf.sd.d.af.f.prm),ws,fsys,false,procfunc) ;
     }
     else {
      mkset(&ws,rparent,semicolon,colon,-1);
      pfparmlist(&(lcp->n.pf.sd.d.af.f.prm),ws,fsys,false,procfunc) ;
      functype(fsys,lcp,false);         /* ֐̌^̏             */
     }

     if(kind == normal) {               /* ubNƌ鎞     */
      updatelc(align(intptr,lc) - lc) ;
      lcp->n.pf.sd.d.af.f.levadr = lc ; /* ̂AhX     */
      updatelc(intsize) ;
      updatelc(align(nilptr,lc) - lc) ; 
      lcp->n.pf.sd.d.af.f.adradr = lc ; /*sAhX̂AhX*/
      updatelc(ptrsize) ;                                  
     }

     top = oldtop ;
}

/*****************************************/
/* prmvarlist() : ϐlp[^  */
/*****************************************/
static void prmvarlist(Set fsys,Set fpfsys,ctp **fcp1,prmkind kind)
{
  enum idkind lkind ;                   /* actual  lp[^
                                           formal  ϐp[^  */
  ctp *lcp,*lcp2,*lcp3 ;
  stp *lsp             ;
  int count  = 0       ;
  int number = 0       ;
  int lsize            ;
  int llc              ;
  boolean test         ;
  Set ws               ;

     if(sy == varsy) {
      lkind = formal ;                  /* var̕t͕̂ϐ    */
      insymbol()     ;
     }
     else lkind = actual ;              /* vartȂΒl    */

     lcp2 = nil ;
     do {
      if(sy == ident) {
       lcp = mkctp(id,vars,nil,lcp2) ;  /* ϐp̃GAm       */
       lcp->n.v.vkind = lkind ;
       lcp->n.v.vlev  = level ;
       enterid(lcp) ;
       lcp2 = lcp ;
       count++    ;
       insymbol() ;
      }
      mkset(&ws,comma,colon,-1);
      orset(&ws,&fpfsys) ;
      if(! inset(ws,sy)) {
       pcerr(7,"") ;                    /* ̕тɌ肪     */
       addset(ws,rparent);
       skip(ws)    ;                    /* ǂݔ΂                 */
      }
      if(test=(sy==comma)) insymbol() ; /* , ȂΎsymbolǂ   */
     } while(test) ;                    /* , ȂΎ̖Ȍ     */

     if(sy == colon) {
      insymbol() ;
      if(sy == ident) {
       mkset(&ws,types,-1) ;
       lcp = searchid(ws)  ;            /* ^T                 */
       applied(lcp,top)    ;            /* p`F[             */
       lsp = lcp->idtype   ;
       lsize = ptrsize     ;            /*zںޥϐ=ڽ*/
       if(lsp)
        if(lkind == actual)             /* lp[^               */
         if(lsp->form <= power) lsize = lsp->size ; /* פ͈߲ͤW */
         else if(!lsp->assignflag) pcerr(121,"");
                                        /* t@C̗vf^ƂċȂ*/
       if(kind == normal) {             /* ubNƌ   */  
        lsize = align(parmptr,lsize) ;  /* p[^Xg̋E */
        updatelc(align(parmptr,lc) - lc);
        updatelc(count*lsize)        ;  /* p[^Xg̈m */
       }

       llc  = lc   ;
       lcp3 = lcp2 ;                    /* ϐт̍Ō̕ϐ̖OAhX*/
       while(lcp2) {                    /* eϐɃGA */
        lcp = lcp2;
        lcp2->idtype = lsp ;            /* ^                         */
        lcp2->linkno = (char)number++ ; /* `Nԍ             */
        if(kind == normal) {            /* ubNƌ   */
         llc -= lsize ;
         lcp2->n.v.vaddr = llc ;        /* AhX           */
        } 
        lcp2 = lcp2->next ;
       }
       lcp->next = *fcp1 ;              /* `F[Ă     */
       *fcp1 = lcp3 ;                   /* Ăяô߂       */

       insymbol() ;
      }
      else pcerr(2,"") ;                /* OȂ                 */

      mkset(&ws,semicolon,rparent,-1);
      orset(&ws,&fpfsys) ;
      if(! inset(ws,sy)) {
       pcerr(7,"") ;                    /* ̕тɌ肪     */
       skip(ws)    ;                    /* ǂݔ΂                 */
      }
     }
     else pcerr(5,"") ;                 /* : Ȃ                   */
}
